Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
Fitness.idl
1/* SPDX-License-Identifier: BSD-3-Clause */
2/*
3 * Copyright 2010 Raritan Inc. All rights reserved.
4 */
5
6/** %Fitness Daemon */
7module fitness {
8
9 /** %Fitness Daemon interface */
10 interface Fitness {
11
12 /** The value/worstValue/rawValue is invalid (e.g. not initialized). */
13 constant int FLAG_VALUE_INVALID = 0x1;
14
15 /** The value/rawValue is out-dated. */
16 constant int FLAG_VALUE_OLD = 0x2;
17
18 /** Violating the threshold is a critical event. */
19 constant int FLAG_ENTRY_CRITICAL = 0x4;
20
21 /** An entry in the reliability database */
22 structure DataEntry {
23 string id; /**< unique id of the entry */
24 int value; /**< normalized value */
25 int maxValue; /**< maximum possible normalized value */
26 int worstValue; /**< worst normalized value seen yet */
27 int thresholdValue; /**< normalized threshold value */
28 long rawValue; /**< raw value */
29 int flags; /**< flags (see above) */
30 };
31
32 /**
33 * An entry in the reliability error log
34 *
35 * An error log entry is made when the normalized value of a data entry
36 * drops below the normalized threshold value.
37 */
38 structure ErrorLogEntry {
39 string id; /**< id of the associated data entry */
40 int value; /**< normalized value */
41 int thresholdValue; /**< normalized threshold value */
42 long rawValue; /**< raw value */
43 int powerOnHours; /**< power on hours when error occured */
44 time timeStampUTC; /**< UTC time stamp when error occured */
45 };
46
47 /**
48 * @brief Returns the fitness data entries.
49 *
50 * The count of entries depends on the device. For example a PDU each
51 * sub controller currently has 3 entries + 2 entries per relay. The
52 * data is updated only once or twice a minute.
53 *
54 * @return -- the vector with the fitness data entries
55 */
56 vector<DataEntry> getDataEntries();
57
58 /**
59 * @brief Returns the error log index range.
60 *
61 * @param firstIndex -- the first valid index
62 * @param entryCount -- the count of entries in the error log
63 */
64 void getErrorLogIndexRange(out int firstIndex, out int entryCount);
65
66 /**
67 * @brief Returns the error log.
68 *
69 * If the startIndex is smaller than the first index in the log than
70 * the count of returned entries is smaller (or even 0) as well.
71 *
72 * @param startIndex -- the index of the first entry to return
73 * @param count -- the count of entries starting from the startIndex
74 * @return -- the vector with the error log entries
75 */
76 vector<ErrorLogEntry> getErrorLogEntries(in int startIndex, in int count);
77
78 };
79
80}
fitness::Fitness
Fitness Daemon interface
Definition Fitness.idl:10
fitness::Fitness::getDataEntries
vector< DataEntry > getDataEntries()
Returns the fitness data entries.
fitness::Fitness::getErrorLogEntries
vector< ErrorLogEntry > getErrorLogEntries(in int startIndex, in int count)
Returns the error log.
fitness::Fitness::getErrorLogIndexRange
void getErrorLogIndexRange(out int firstIndex, out int entryCount)
Returns the error log index range.
fitness
Fitness Daemon
Definition Fitness.idl:7
fitness::Fitness::DataEntry
An entry in the reliability database.
Definition Fitness.idl:22
fitness::Fitness::DataEntry::id
string id
unique id of the entry
Definition Fitness.idl:23
fitness::Fitness::DataEntry::maxValue
int maxValue
maximum possible normalized value
Definition Fitness.idl:25
fitness::Fitness::DataEntry::thresholdValue
int thresholdValue
normalized threshold value
Definition Fitness.idl:27
fitness::Fitness::DataEntry::value
int value
normalized value
Definition Fitness.idl:24
fitness::Fitness::DataEntry::rawValue
long rawValue
raw value
Definition Fitness.idl:28
fitness::Fitness::DataEntry::flags
int flags
flags (see above)
Definition Fitness.idl:29
fitness::Fitness::DataEntry::worstValue
int worstValue
worst normalized value seen yet
Definition Fitness.idl:26
fitness::Fitness::ErrorLogEntry
An entry in the reliability error log.
Definition Fitness.idl:38
fitness::Fitness::ErrorLogEntry::timeStampUTC
time timeStampUTC
UTC time stamp when error occured.
Definition Fitness.idl:44
fitness::Fitness::ErrorLogEntry::rawValue
long rawValue
raw value
Definition Fitness.idl:42
fitness::Fitness::ErrorLogEntry::powerOnHours
int powerOnHours
power on hours when error occured
Definition Fitness.idl:43
fitness::Fitness::ErrorLogEntry::thresholdValue
int thresholdValue
normalized threshold value
Definition Fitness.idl:41
fitness::Fitness::ErrorLogEntry::id
string id
id of the associated data entry
Definition Fitness.idl:39
fitness::Fitness::ErrorLogEntry::value
int value
normalized value
Definition Fitness.idl:40